searchNodes=[{"doc":"Alltid offers a simplified approach to editing deeply nested immutable data structures in Elixir. Inspired by Immer.js in JavaScript, Alltid allows a natural declarative syntax for manipulating deeply nested immutible data structures.","ref":"Alltid.html","title":"Alltid","type":"module"},{"doc":"Produce an update to value using the provided fun , a function of arity 1. Within the provided function, the &lt;- operator can be used to simulate assignment of nested values within the provided argument: iex&gt; Alltid . produce ( %{ counter : 10 } , fn draft -&gt; ...&gt; draft [ :counter ] &lt;- draft [ :counter ] + 1 ...&gt; draft [ :value ] &lt;- &quot;some value&quot; ...&gt; end ) %{ counter : 11 , value : &quot;some value&quot; } Returns a copy of value with the changes from fun applied.","ref":"Alltid.html#produce/2","title":"Alltid.produce/2","type":"macro"},{"doc":"Alltid offers a simplified approach to editing deeply nested immutable data structures in Elixir. Inspired by Immer.js in JavaScript, Alltid allows a natural declarative syntax for manipulating deeply nested immutible data structures. require Alltid data = %{ accounts : [ %{ id : 1 , balance : 200 } , %{ id : 2 , balance : 150 } ] } next = Alltid . produce ( data , fn draft -&gt; draft [ :accounts ] [ 0 ] [ :balance ] &lt;- draft [ :accounts ] [ 0 ] [ :balance ] + 50 draft [ :accounts ] [ 1 ] [ :balance ] &lt;- draft [ :accounts ] [ 1 ] [ :balance ] - 50 end ) This example is simply syntactic sugar for the following: data = %{ accounts : [ %{ id : 1 , balance : 200 } , %{ id : 2 , balance : 150 } ] } data |&gt; put_in ( [ :accounts , Access . at ( 0 ) , :balance ] , get_in ( [ :accounts , Access . at ( 0 ) , :balance ] ) + 50 ) |&gt; put_in ( [ :accounts , Access . at ( 1 ) , :balance ] , get_in ( [ :accounts , Access . at ( 1 ) , :balance ] ) - 50 ) Though Alltid's produce pattern may appear to violate the spirit of functional programming, it simply uses Elixir's macro system and variable bindings to enable a more natural and familiar syntax, entirely isolated to the function passed in to Alltid.produce . The code is still entirely functional.","ref":"readme.html","title":"Alltid","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding alltid to your list of dependencies in mix.exs : def deps do [ { :alltid , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/alltid .","ref":"readme.html#installation","title":"Alltid - Installation","type":"extras"}]